# -*- coding: UTF-8 -*-

#!!  ListData解析、grep_py2 etc
# 使用例
# import my_module as mmd

# if mmd.is_ascii(fn) == False:   # ascii文字以外が入っていたら処理を飛ばす
#   continue

# grep_py("環境", *MAC)

# for file in find_all_files('/home/acad/files3/kaok/','.icd','rec'):

# 履歴
# 2019.9.17     find_all_files  拡張子の.補完
# 2022.2.5      def mk_shortcut(fn_lnk, fp_fn): #ショートカット作成
# 2022.2.20     divmod2 追加　浮動小数点で商と余りを求める
# 2022.2.22     winbeep 警告音追加
# 2022.3.15     sby_anl追加
# 2022.3.17     grep_py2 追加 正規表現使用可
# 2022.5.1      画面位置保存、読み込み関数 def save_geometry(fn, config),  def read_geometry(fn)
# 2022.5.19     2次方程式の根を求める   
# 2024.7.6      shape_fn(fn0, ext= '', sep= '/'):   # File Nameを整形する
#               shape_fld(fld0, sep= '/'):          # Folder Nameを整形する
# 2024.8.24     pykakasiを除外

import subprocess
import winsound as wsd
import os
import binascii
import re
import time
import datetime
import zen_han      #全角<-->半角変換
import sys
import codecs               # 文字コードの操作
import my_tk as mtk
#from pykakasi import kakasi     # カナ漢字変換
#kks = kakasi()


# 文字着色 表示色　e.x.  mmd.Color.BLACK　
class Color:
    BLACK     = '\033[30m'
    RED       = '\033[31m'
    GREEN     = '\033[32m'
    YELLOW    = '\033[33m'
    BLUE      = '\033[34m'
    PURPLE    = '\033[35m'      #紫　見えない
    CYAN      = '\033[36m'
    WHITE     = '\033[37m'
    END       = '\033[0m'
    BOLD      = '\038[1m'
    UNDERLINE = '\033[4m'       # Under Line
    INVISIBLE = '\033[08m'      # Default    
    REVERCE   = '\033[07m'      # 反転    

# os.system('cls')
# col = mmd.Color.GREEN; col_end = mmd.Color.END

#----------------------------------------------------------
#       ListData解析 整理番号（行番号）と図番を抽出
#----------------------------------------------------------
def sby_anl(fp_fn):     # ListData解析
    #list_path = 'c:/ACAD/'
    work_path = 'c:/ACAD/'

    # ListDataにアクセス
    cmd = '7z.exe x -y -o' + work_path + ' ' + fp_fn + ' PartsListM.db' 
    os.system(cmd)            
    #time.sleep(1)        # 1秒お休み

    f = open((work_path+'PartsListM.db'),'rb')            # 引数で指定したバイナリファイルをオープン
    buffer = str(binascii.hexlify(f.read()),'utf-8')       # file全体を変数 buffer に読み込む
    f.close()                                 # 入力 File close
    #print(buffer)  #!!!

    pattern0 = [r'bff0{13}bff00{12}',  #1
            r'bff0{13}c0000{12}',  #2
            r'bff0{13}c0080{12}',  #3
            r'bff0{13}c0100{12}',  #4
            r'bff0{13}c0140{12}',  #5
            r'bff0{13}c0180{12}',  #6
            r'bff0{13}c01c0{12}',  #7
            r'bff0{13}c0200{12}',  #8
            r'bff0{13}c0220{12}',  #9
            r'bff0{13}c0240{12}',  #10
            r'bff0{13}c0260{12}',  #11
            r'bff0{13}c0280{12}',  #12
            r'bff0{13}c02a0{12}',  #13
            r'bff0{13}c02c0{12}',  #14
            r'bff0{13}c02e0{12}',  #15
            r'bff0{13}c0300{12}',  #16
            r'bff0{13}c0310{12}',  #17
            r'bff0{13}c0320{12}',  #18
            r'bff0{13}c0330{12}',  #19
            r'bff0{13}c0340{12}',  #20
            r'c000{13}bff00{12}',  #21
            r'c000{13}c0000{12}',  #22 ??
            r'c000{13}c0080{12}',  #23
            r'c000{13}c0100{12}',  #24
            r'c000{13}c0140{12}',  #25
            r'c000{13}c0180{12}',  #26
            r'c000{13}c01c0{12}',  #27
            r'c000{13}c0200{12}',  #28
            r'c000{13}c0220{12}',  #29
            r'c000{13}c0240{12}',  #30
            r'c000{13}c0260{12}',  #31
            r'c000{13}c0280{12}',  #32
            r'c000{13}c02a0{12}',  #33
            r'c000{13}c02c0{12}',  #34
            r'c000{13}c02e0{12}',  #35
            r'c000{13}c0300{12}',  #36
            r'c000{13}c0310{12}',  #37
            r'c000{13}c0320{12}',  #38
            r'c000{13}c0330{12}',  #39
            r'c000{13}c0340{12}',  #40
            r'c0080{12}bff00{12}', #41
            r'c0080{12}c0000{12}', #42
            r'c0080{12}c0080{12}', #43
            r'c0080{12}c0100{12}', #44
            r'c0080{12}c0140{12}', #45
            r'c0080{12}c0180{12}', #46
            r'c0080{12}c01c0{12}', #47
            r'c0080{12}c0200{12}', #48
            r'c0080{12}c0220{12}', #49
            r'c0080{12}c0240{12}', #50
            r'c0080{12}c0260{12}', #51
            r'c0080{12}c0280{12}', #52
            r'c0080{12}c02a0{12}', #53
            r'c0080{12}c02c0{12}', #54
            r'c0080{12}c02e0{12}', #55
            r'c0080{12}c0300{12}', #56
            r'c0080{12}c0310{12}', #57
            r'c0080{12}c0320{12}', #58
            r'c0080{12}c0330{12}', #59
            r'c0080{12}c0340{12}', #60
            r'c0100{12}bff00{12}', #61
            r'c0100{12}c0000{12}', #62
            r'c0100{12}c0080{12}', #63
            r'c0100{12}c0100{12}', #64
            r'c0100{12}c0140{12}', #65
            r'c0100{12}c0180{12}', #66
            r'c0100{12}c01c0{12}', #67
            r'c0100{12}c0200{12}', #68
            r'c0100{12}c0220{12}', #69
            r'c0100{12}c0240{12}', #70
            r'c0100{12}c0260{12}', #71
            r'c0100{12}c0280{12}', #72
            r'c0100{12}c02a0{12}', #73
            r'c0100{12}c02c0{12}', #74
            r'c0100{12}c02e0{12}', #75
            r'c0100{12}c0300{12}', #76
            r'c0100{12}c0310{12}', #77
            r'c0100{12}c0320{12}', #78
            r'c0100{12}c0330{12}', #79
            r'c0100{12}c0340{12}', #80
            r'c0140{12}bff00{12}', #81
            r'c0140{12}c0000{12}', #82
            r'c0140{12}c0080{12}', #83
            r'c0140{12}c0100{12}', #84
            r'c0140{12}c0140{12}', #85
            r'c0140{12}c0180{12}', #86            
            r'c0140{12}c01c0{12}', #87
            r'c0140{12}c0200{12}', #88
            r'c0140{12}c0220{12}', #89
            r'c0140{12}c0240{12}', #90
            r'c0140{12}c0260{12}', #91
            r'c0140{12}c0280{12}', #92
            r'c0140{12}c02a0{12}', #93
            r'c0140{12}c02c0{12}', #94
            r'c0140{12}c02e0{12}', #95
            r'c0140{12}c0300{12}', #96
            r'c0140{12}c0310{12}', #97
            r'c0140{12}c0320{12}', #98
            r'c0140{12}c0330{12}', #99
            r'c0140{12}c0340{12}'] #100

    zuban_list = []
    idx0 = 4000

    print('\n  ' + os.path.basename(fp_fn) + 'の解析を実施します\n')

    i = 1;  flg = 0
    for ptn in pattern0:
        #print(ptn)  #!!!
        match_obj = re.search(ptn,buffer[idx0:])
        #time.sleep(0.1)   #!!!
        if match_obj:
            idx1 = match_obj.end()
            idx2 = idx0+idx1
            ss0 = ptn[8:13]; ss1 = buffer[idx2:idx2+5]
            # tmp0 = buffer[(idx2+20):(idx2+44)]
            tmp0 = buffer[(idx2+20):(idx2+46)]      # 図番　bin
            zbn = str(binascii.unhexlify(tmp0),'shift-jis')    # 図番 ASCII
            #print(zbn)  #!!!
            if zbn.isalnum() == False:     # zbnに英数字以外が含まれていたら
                #idx3 = tmp2.find('00')       # \x00の位置を検出
                idx3 = zbn.find('\x00')       # \x00の位置を検出
                zbn = zbn[0:idx3] #+ '_!'       # \x00以下の文字を削除して'-'を追加
            
            if len(zbn) < 6:
                continue

            tmp0 = buffer[(idx2+48):(idx2+74)]      # 品名　bin
            #hinmei0 = str(binascii.unhexlify(tmp0),'utf-8')    # 品名ASCII
            #print(tmp0)
            try:
                hinmei0 = str(binascii.unhexlify(tmp0),'shift-jis')    # 品名ASCII
                hinmei = zen_han.Han2Zen(hinmei0).replace('\0', '')    #  \0を削除
                #hinmei1 = hinmei0.replace('\0', '')    #  \0を削除
                #hinmei = zen_han.Han2Zen(hinmei1,ASCII|KANA)    #NG
                #hinmei = zen_han.Han2Zen(hinmei1)   
                #print(hinmei0, hinmei1, hinmei)  #!!!
                #print(hinmei)  #!!!
            except:
                print('%s の品名の取り込みに失敗しました' % zbn)
                continue

            tmp0 = buffer[(idx2+252):(idx2+254)]      # Dell　bin
            del_mark0 = str(binascii.unhexlify(tmp0),'shift-jis')    # Dell ASCII
            if del_mark0 == '\x00':
                del_mark = '-'
            else:
                del_mark = 'Del'

            zuban_list.append([i,zbn, hinmei, del_mark])
            #print(i,zbn,hinmei,del_mark)    #!!!
            idx0 = idx2 
        #else:
        #    print('%d マッチオブジェクトがありません %s' % (i, ptn))

        i += 1
    return zuban_list   # [整理番号, 図番、品名（コメント）、削除マーク] 


#---------------------------------------------------------------------
#       Path Listと拡張子を指定して、ファイルリストをout_fnに書き出す
#---------------------------------------------------------------------
def make_file_db(ext, out_fn, *path_list):  # 
    for i in range(len(path_list)):
        if i == 0:
            cmd = 'dir /o:g /s /b ' + path_list[0] + '*' + ext + ' > ' + out_fn
            print(cmd)
            os.system(cmd)
        else:
            cmd = 'dir /o:g /s /b ' + path_list[i] + '*' + ext + ' >> ' + out_fn
            print(cmd)
            os.system(cmd)

#--------------------------------------------------
#   Fileの更新日を取得
#--------------------------------------------------
def get_fn_date(fp_fn):     # fp_fnのタイムスタンプ取得　年月日時分
    dt = datetime.datetime.fromtimestamp(os.stat(fp_fn).st_mtime)
    ss_dt = dt.strftime('%Y/%m/%d/%H:%M')  #datetime->文字列
    return ss_dt    # 2023/11/20/15:10


#--------------------------------------------------
#   Fileの更新日を設定
#--------------------------------------------------
def set_fn_date(fp_fn, y,m,d,h,mi,s):     # fp_fnのタイムスタンプ設定
    mtime= datetime.datetime(y,m,d,h,mi,s).timestamp()  # 更新日 ファイル最終アクセス日(同時刻設定)
    atime= mtime
    os.utime(fp_fn, (atime, mtime))

def conv_ss_dt(ss_dt):  # ss_dt= get_fn_date より((y,m,d,h,mi)取得
    ss= ss_dt.split('/')
    y= int(ss[0])
    m= int(ss[1])
    d= int(ss[2])
    ss_hm= ss[3].split(':')
    h= int(ss_hm[0])
    mi= int(ss_hm[1])
    
    return (y,m,d,h,mi)    


#----------------------------------
#   警告音
#----------------------------------
def winbeep():
    #import winsound as wsd
    f0 = 520; num = 2; fc = 50
    for f in range(f0, f0-num*fc, -fc):
        wsd.Beep(f,200)    

#----------------------------------
#   浮動小数点の商と余りを求める
#----------------------------------
def divmod2(f0, f1, keta = 10):  # f0 / f1 = 商, 余り　keta: 丸める桁数
    d = round(f0/f1, 10)
    m = round(f0-int(d)*f1, keta)
    #d = round(f0/f1, 0)
    #m = round(f0-d*f1, keta)
    return (int(d),m)
    #return (d,m)

#----------------------------------------
#   ショートカット作成
#----------------------------------------
def mk_shortcut(fn_lnk, fp_fn):
    cmd = 'shortcut.bat %s %s' % (fn_lnk, fp_fn)
    #print(cmd)
    result = subprocess.call(cmd,shell=True)
    #result = subprocess.Popen(cmd,shell=True)



# grep の　Python版 正規表現版
def grep_py2(str0,fname,fcodec='utf-8'): #     'shift_jis','euc_jp'.'utf-8','cp932'
           #(正規表現, 検索対象文字列 or File)
    import os
    #import sys
    #import codecs               # 文字コードの操作
    import re

    if isinstance(fname,str):       # Fileを対象
        if os.path.exists(fname):     # Fileが存在するなら
            fp = codecs.open(fname,"r",fcodec)
            lines0 = fp.readlines()
            fp.close()
    elif isinstance(fname,list):    # list対象
        lines0 = fname
    else:
        lines0 = fname
  
    lines = []
    for line in lines0:
        if re.search(str0, line):    # Noneでないなら
            lines.append(line)
  
    return lines



# grep の　Python版
def grep_py(str0,fname,fcodec='utf-8'): #     'shift_jis','euc_jp'.'utf-8','cp932'
    import os
    #import sys
    #import codecs               # 文字コードの操作
  
    if isinstance(fname,str):       # Fileを対象
        if os.path.exists(fname):     # Fileが存在するなら
            fp = codecs.open(fname,"r",fcodec)
            lines0 = fp.readlines()
            fp.close()
    elif isinstance(fname,list):    # list対象
        lines0 = fname
    #    print '%s は文字列です' % (lines0)
    else:
        lines0 = fname
  
    lines = []
    for line in lines0:
        if line.find(str0) >= 0:
    #      print line,    #2.7
    #      print(line[:-1])    #3.5
            lines.append(line)
  
    return lines
   

# 文字列 u がASCIIだけなら True ASCII以外を含むならFalse
def is_ascii2(u):    # Python　2用
    try:
        if isinstance(u, unicode):
            u.encode('ascii')
        elif isinstance(u, str):
            u.decode('ascii')
        else:
            return False
        return True
    except:
        return False

#-----------------------------------------------------------
#   文字種判定
#-----------------------------------------------------------
# 文字列 u がASCIIだけなら True ASCII以外を含むならFalse
def is_ascii(u):   # Python 2 and 3用
    #import re
    asciiReg = re.compile(r'^[!-~]+$')
    return asciiReg.match(u) is not None


# 文字列 u が全て半角カナなら True
def is_han_kana(u):
    #import re
    asciiReg = re.compile('[\uFF61-\uFF9F]')
    return asciiReg.match(u) is not None

# 文字列 ss が半角文字だけ(全角文字を含まない)なら True
def is_hankaku(ss):
    import unicodedata as ucd
    for char in ss:
        ret= ucd.east_asian_width(char)
        #print(ret)
        if ret== 'H' or ret== 'Na': # 半角カナ、半角英数字
            continue
        else:
            return False
    return True


''' 
# pykakasiを使って漢字を全角カナに変換
def kanji2kana(ss):
    #print(ss)
    res = kks.convert(ss)
    #print(res)
    ss2= ''
    for dic in res:
        #print('     %d dic_kana: %s' % (cnt, dic['kana']))  ###
        tmp_ss= dic['kana']
        ss2= ss2+ tmp_ss
    #print('     %d kakasi convert: %s' % (cnt,ss2)) ###

    return ss2
'''




# Pathと拡張子を指定してFile nameを返す。opt==cur:Curent dir  opt==rec:Recursive(再帰的)
def find_all_files(directory,extension,opt):   # extension(拡張子)
    #import os
    if extension[0] != '.': extension = '.' + extension
    flg = 0  
    for root, dirs, files in os.walk(directory):  # root:full path dir name  dirs:directory list  files:file list 
        #print('flg=' + str(flg) + '  ' + str(len(dirs)))
        if opt == 'cur' and flg == 0:  # Path直下のファイルのみ
            for file in files:
                ss_fn,ext = os.path.splitext(file)
                if ext == extension:
                    yield os.path.join(root, file)    # Full Path表示を返す
        elif opt == 'rec':
            for file in files:
                ss_fn,ext = os.path.splitext(file)
                if ext == extension:    
                    yield os.path.join(root, file)    # Full Path表示を返す
        flg = 1

# end of find_all_files

def get_time_stamp(fp_fn, mode):   # ymdh:年月日時     ymdhm:年月日時分   mdhm:月日時分
    import datetime                 # 日付、時間
    import os

    d = datetime.datetime.fromtimestamp(os.path.getctime(fp_fn))     # タイムスタンプ日付、時間
    #print(d.day)
    year2 = d.year - 2000
    if d.year < 10:  ss_year = '0%s' % (year2)
    else: ss_year = '%s' % (year2)
    if d.month < 10:  ss_month = '0%s' % (d.month)
    else: ss_month = '%s' % (d.month)
    if d.day < 10:  ss_day = '0%s' % (d.day)
    else: ss_day = '%s' % (d.day)
    if d.hour < 10:  ss_hour = '0%s' % (d.hour)
    else: ss_hour = '%s' % (d.hour)
    if d.minute < 10:  ss_hour = '0%s' % (d.minute)
    else: ss_minute = '%s' % (d.minute)

    if mode == 'ymdh': # 年月日時
        tmp = '%s%s%s%s' % (ss_year, ss_month, ss_day, ss_hour)        # 31511600C77_20062512
    elif mode == 'ymdhm': # ymdhm:年月日時分    
        tmp = '%s%s%s%s%s' % (ss_year, ss_month, ss_day, ss_hour, ss_minute)      # 31511600C77_2006251258
    elif mode == 'mdhm': # mdhm:月日時分    
        tmp = '%s%s%s%s' % (ss_month, ss_day, ss_hour,ss_minute)      # 31511600C77_06251258

    return tmp

def save_geometry(fn, ss_geom):
    path = sys.exec_prefix  # C:\online\Python37
    fp_fn = path + '\\' + fn
    #print(fp_fn)    #!!!
    fp = codecs.open(fp_fn,'w','utf-8')
    fp.write(ss_geom)
    fp.close()

def read_geometry(fn):
    path = sys.exec_prefix  # C:\online\Python37
    fp_fn = path + '\\' + fn
    
    if not os.path.exists(fp_fn):
        return None

    fp = codecs.open(fp_fn,'r','utf-8')
    #lines = fp.readlines()
    line = fp.readline()
    fp.close()
    #for line in lines:
    #    if line.find('#') > -1:   # '#'を含む行はスキップ コメント行除外
    #        continue
    #    ss_geom = line.rstrip()    # 行末の改行を削除
    ss_geom = line.rstrip()    # 行末の改行を削除

    return ss_geom
    

# 2次方程式を解く  ルート内がマイナスの場合は複素数表現
def sqe(a,b,c):     # solv_quadratic_equation(a,b,c):
    D = (b**2 - 4*a*c) ** (1/2)
    x_1 = (-b + D) / (2 * a)
    x_2 = (-b - D) / (2 * a)
    if type(D) == complex:
        hantei = D
        #hantei = -1
    elif D == 0:
        hantei = 0.0
    else:
        hantei = 1.0
    return x_1, x_2, hantei   


# 2次方程式を解く2  ルート内がマイナスの場合は複素数表現
def sqe2(a,b,c):     # solv_quadratic_equation(a,b,c):
    jdg = b**2 - 4*a*c
    if jdg < 0:
        return (None, None, jdg)
    elif jdg == 0:
        x = -b /2/a
        return (x, x, jdg)
    else:
        x_p = (-b + jdg**(0.5)) /2/a
        x_m = (-b - jdg**(0.5)) /2/a
    return (x_p, x_m, jdg)

#----------------------------------
#   File Nameを整形する
#----------------------------------
def shape_fn(fn0, ext= '', sep= '/'):
    fn= fn0
    if fn0.find(ext) > -1: # ex. fn0= 'aaa.icd', ect='icd'
        ext= ''
    if not ext== '' :
        if ext[0]== '.':
            fn= '%s%s' % (fn0, ext)
        else:   # .無し
            fn= '%s.%s' % (fn0, ext)

    if sep== '/':  
        fn= fn.replace('\\', sep)
    elif sep== '\\':
        fn= fn.replace('/', sep)
    else:
        mtk.warning('セパレータ %s に間違いがあります' % sep)
        return None
    
    if os.path.exists(fn):  # File存在確認
        return fn
    else:
        mtk.warning('%s は存在しません' % fn)
        return None

#--------------------------------------------------
#   Folder Nameを整形する 最後の'/'が無ければつける
#--------------------------------------------------
def shape_fld(fld0, sep= '/'):
    fld= fld0
    if sep== '/':  
        fld= fld0.replace('\\', sep)
        if not fld[-1]== sep:  # ex. y:/test
            fld= fld+ '/'
    elif sep== '\\':
        fld= fld0.replace('/', sep)
        if not fld[-1]== sep:  # ex. y:\test
            fld= fld+ '\\'

    else:
        mtk.warning('セパレータ %s に間違いがあります' % sep)
        return None
    
    if os.path.exists(fld):  # Folder存在確認
        return fld
    else:
        mtk.warning('%s は存在しません' % fld)
        return None



#--------------------------------------
#   メインルーチン
#--------------------------------------
if __name__ == '__main__':
    import sys
    if len(sys.argv) < 2:   #引き数無し !!!引数無 !!!argv
        menu =1
    elif len(sys.argv)== 2:    # 引数１個 
        menu = int(sys.argv[1])
    elif len(sys.argv)== 3:    # 引数2個 
        menu= int(sys.argv[1])
        fp_fn= sys.argv[2]

    if menu== 12:   # set_fn_date
        y,m,d,h,mi,s= input('y,m,d,h,mi,s= ').split()
        y= int(y)
        m= int(m)
        d= int(d)
        h= int(h)
        mi= int(mi)
        s= int(s)
        set_fn_date(fp_fn, y,m,d,h,mi,s)

    if menu== 11:   # set_fn_date(fp_fn, y,m,d,h,m,s)
        (y,m,d,h,mi,s)= (2010,1,2,3,4,5)
        set_fn_date(fp_fn, y,m,d,h,mi,s)
        
    if menu== 10: # get_time_stamp(fp_fn, mode)
        ss_dt= get_fn_date(fp_fn)
        print(ss_dt)
        (y,m,d,h,mi)= conv_ss_dt(ss_dt)
        print('%d年%d月%d日_%d時%d分' % (y,m,d,h,mi))


    if menu == 9:
        f1 = 10.599999; f2 = 0.2
        (d, m) = divmod2(f1,f2)
        print(d, m, type(d), type(m))

    if menu == 8:   #2次方程式
        a=1; b=2; c=3
        (x1, x2, hantei) = sqe(a,b,c)
        print(x1, x2, hantei)   # (-0.9999999999999999+1.4142135623730951j) (-1-1.4142135623730951j)  -1
        print(x1+x2)    # (-2+0j)
        print(type(x1)) # <class 'complex'>
        a=1; b=2; c=1
        (x1, x2, hantei) = sqe(a,b,c)
        print(x1, x2, hantei)   # -1.0 -1.0 0 
        print(type(x1)) # <class 'float'>
        a=1; b=3; c=1
        (x1, x2, hantei) = sqe(a,b,c)
        print(x1, x2, hantei)   #  -0.3819660112501051 -2.618033988749895 1
        print(type(x1)) # <class 'float'>
        a=1; b=28; c=-40
        (x1, x2, hantei) = sqe(a,b,c)
        print(x1, x2, hantei)   #  -0.3819660112501051 -2.618033988749895 1



    if menu == 7:
        winbeep()

    if menu == 6:
        ssl = ['810112115500', '123456789012', '810112125501', '1234abcdefghijklmn'] 
        #ss1 = '810112*'         # ['810112115500', '810112125501']
        #ss1 = '810112??550?'   # NG
        #ss1 = '810112*5500'   # NG
        #ss1 = '81011211550?'   # ['810112115500']
        #ss1 = '8101121[1-2]550?'   # ['810112115500', '810112125501']
        #ss1 = '[a-z]'   # ['1234abcdefghijklmn']
        #ss1 = '810112[1-9][1-9]550?'   #['810112115500', '810112125501']

        mach_obj_list = grep_py2(ss1, ssl)
        print(mach_obj_list)


    if menu == 1:   # grep_py test
        import os
        ss0 = '315110116'
        if os.name == 'posix':   # linux Linux
            fn = '/home/acad/files/kensaku_db_files'
            path = '/home/acad/files3/'
        elif os.name == 'nt':    # windows
            fn = 'x:\\kensaku_db_files'
            path = 'y:/'

        #print(os.name,fn)
        arr0 = grep_py(ss0,fn)
        #print(arr0)
        for line in arr0:
            tmp = line.split(" ")
            zuban = tmp[0]
            hinmei = tmp[1].rstrip()      # 行末の改行を削除
            print(zuban,hinmei,)

    if menu == 2:   #is_ascii
        #  zuban1 = 'A2あｲｳｴｵ'
        zuban1 = '1234.MDL'
        if is_ascii(zuban1):
            print(zuban1 + ' は ASCII :isascii')
        else:
            print(zuban1 + ' は ASCII 以外を含む')

        if is_ascii2(zuban1):
            print(zuban1 + ' は ASCII :isascii3')
        else:
            print(zuban1 + ' は ASCII 以外を含む')

    if menu == 3:  #find_all_files test
        # directoryと拡張子を指定してFile nameを返す(1)
        i = 1
        fld = path + 'EPS/'
        print(fld)
        for file in find_all_files(fld, '.icd','rec'):
        #for file in find_all_files('y:\EPS', '.icd','rec'):
            print(str(i) + ' ' + file)
            i += 1

        i = 1
        fld = path + 'EPS/'
        fp_fn_list = find_all_files(fld, '.icd','cur')
        for file in fp_fn_list:
            print(str(i) + ' ' + file)
            i += 1

        # 年月日を返す
        print(get_time_stamp('y:/EPS/31511057553.icd','ymdhm'))

    if menu == 4:   # mk_shortcut test
        
        import os
        fp_fn = 'y:/test/81012447171.icd'
        fn = os.path.basename(fp_fn)
        tmp = fn.replace('.icd', '.lnk')
        fn_lnk = 'c:/zip/' + tmp
        #fn_lnk = 'c:/zip/' + fn + '.lnk'
        print(fn_lnk)
        mk_shortcut(fn_lnk, fp_fn)

    elif menu == 5:
        fp_fn = 'z:/ListData/30011700050.sby'
        #fp_fn = '3000100000A.sby'
        zuban_list = sby_anl(fp_fn)
        print(len(zuban_list))
        for line in zuban_list:
            print(line[0], line[1], line[2])
